* -------------------------------------------------------- *
*                   DRUCKER.PRG                            *
*   Das Programm demonstriert die Nutzung besonderer       *
*   Druckereigenschaften (Cursor- und Fettdruck, Wechsel   *
*   der Schriftart, etc.) unter dBase.                     *
*                                                          *
*           (c) 1988 by B.Born und TOOLBOX                 *
* -------------------------------------------------------- *

SET TALK OFF
SET ECHO OFF
SET STATUS OFF
CLEAR ALL

* -- Definition der Druckermodes (fr EPSON Drucker) -------

ESC         = CHR(27)             && ESCape-Sequenz
RES         = ESC + '@'           && Drucker Reset
FETTON      = ESC + 'E'           && Fettdruck Ein
FETTOFF     = ESC + 'F'           && Fettdruck Aus
NLQ         = ESC + 'x' + '1'     && Near Letter Quality
DRAFT       = ESC + 'x' + '0'     && Draft Schrift
ROMAN       = ESC + 'k' + '0'     && Roman Schrift, NLQ
SANSSERIF   = ESC + 'k' + '1'     && Sans Serif Schrift, NLQ

* Da CHR(0) in DBASE nicht funktioniert, wird 'A' eingesetzt.
* Damit wird eine Kursiv PICA Schrift erzeugt

PICA        = ESC + '!' + 'A'     && 10 Pitch Pica Schrift
ELITE       = ESC + '!' + CHR(1)  && 12 Pitch Elite Schrift
SCHMALON    = CHR (15)            && Schmalschrift ein
SCHMALOFF   = CHR (18)            && Schmalschrift aus
BREITON     = ESC + 'W' + '1'     && Breitdruck ein
BREITOFF    = ESC + 'W' + '0'     && Breitdruck aus
HOCH        = ESC + 'S' + '0'     && Hochstellung
TIEF        = ESC + 'S' + '1'     && Tiefstellung
NORMAL      = ESC + 'T'           && Ende Hoch-/Tiefstellung
UNTERSTRON  = ESC + '-' + '1'     && unterstreichen Ein
UNTERSTROFF = ESC + '-' + '0'     && unterstreichen Aus
KURSIVON    = ESC + '4'           && Kursivdruck Ein
KURSIVOFF   = ESC + '5'           && Kursivdruck Aus

* Damit wird die Definition  der Druckercodes abgeschlossen

? 'Beginn der Druckerdemo'
SET DEVICE TO PRINT

@ 1,0 SAY RES + 'Ausdruck mit Standardeinstellung'
@ 2,0 SAY NLQ + ROMAN + 'Roman Schrift (NLQ Mode)'
@ 3,0 SAY SANSSERIF +  'Sans Serif Schrift (NLQ Mode)'
@ 4,0 SAY PICA + 'Ausdruck mit Pica Schrift (NLQ Mode)'
@ 5,0 SAY ELITE + 'Ausdruck mit Elite Schrift (NLQ Mode)'
@ 6,0 SAY DRAFT + 'Nun wieder Standard-Schrift'
@ 7,0 SAY FETTON + 'Ausdruck mit Fettschrift' + FETTOFF
@ 8,0 SAY KURSIVON + '... mit Kursivschrift' + KURSIVOFF
@ 9,0 SAY 'Auch Hoch- und Tiefstellungen sind mglich'
@ 10,0 SAY 'Y = X' + HOCH + ' 2' + NORMAL + ' + X '
@ 10,11 SAY TIEF + '(i) ' + NORMAL + ' + 1'
@ 11,0 SAY  BREITON + 'Breite Schriften' + BREITOFF
@ 11,25 SAY SCHMALON + 'und schmale Schriften' + SCHMALOFF
@ 12,0 SAY RES + 'erlauben besondere Druckeffekte'
@ 13,0 SAY UNTERSTRON + 'Unterstreichen funktioniert auch'
@ 13,0 SAY UNTERSTROFF
@ 14,0 SAY 'Damit ist die Demonstration abgeschlossen'
@ 15,0 SAY 'Viel Spa bei eigenen Experimenten'

SET DEVICE TO SCREEN
? 'Ende der Druckerdemo' 
