/*--------------------------------------------*/
/*                QUEUE.H                     */
/*         Headerdatei zu QUEUE.C             */
/*      (C) 1988 R.Ziegaus & TOOLBOX          */
/*--------------------------------------------*/

/* Konstanten */
#define TRUE   1
#define FALSE  0

/* Typen */
typedef struct NodeType
  {
    void                 *Item;
    struct  NodeType     *Next;
    struct  NodeType     *Prev;
  } Node;

typedef struct
  {
    int      Len;
    int      Size;
    Node     *Head;
    Node     *Tail;
  } QueueHead;

/* Funktionsprototypen */
QueueHead *InitQueue(int Size);
void KillQueue(QueueHead *Queue);
int  AppendToQueue(void *data,
                   QueueHead *Queue);
void *GetQueueHead(QueueHead *Queue);
int  QueueLength(QueueHead *Queue);
int  EmptyQueue(QueueHead *Queue);
