(* ------------------------------------------------------ *)
(*                   GR-EDIT2.INC                         *)
(*       Der Editor zum Programm VEKTORGRAPHIK            *)
(*         (c) 1988 Helmut Wessels & TOOLBOX              *)
(* ------------------------------------------------------ *)

procedure edit(b:word);     {Hier beginnt die Editor-Arbeit}
const blink = true;
var off,paar,anz,akt:integer; x,y:shortint;  st:string[4];
    linie,junk:boolean;
    knoten: array[0..255] of word;

  function vec_art(nr:word):tArt; {Identifiziert Vektor-Art}
  begin
    with userfont do
     vec_art:=decodiere_vektor(vect^[nr],vect^[nr+1],rx,ry,junk)
  end;



  procedure rahmen(farbe:word);
  begin                    {Umrahmt angesteuertes Zahlenpaar}
     setColor(farbe);
     if GraphDriver>MCGA then      {hhere Auflsung als CGA}
     rectangle(tx*(akt and $F),cy_t+(ty+1)*(akt shr 4)-ty+2,
               tx*(akt and $F)+tx+1,cy_t+(ty+1)*(akt shr 4)+3);
     rectangle(tx*(akt and $F)+1,cy_t+(ty+1)*(akt shr 4)-ty+1,
               tx*(akt and $F)+tx,cy_t+(ty+1)*(akt shr 4)+2)
  end;



  procedure blinker(on:boolean);
  begin                  {setzt "Blinker" auf Graphik-Punkt}
     if on then setColor(white) else setcolor(black);
     if (vec_art(knoten[akt]) = normal) or
        (vec_art(knoten[akt-1]) = normal)
      then with userfont do
        rectangle(cx_g+round(faktor/korr_faktor*rx)-2,
                  cy_g-faktor*(ry-info^.unterlaengen)-2,
                  cx_g+round(faktor/korr_faktor*rx)+2,
                  cy_g-faktor*(ry-info^.unterlaengen)+2);
     setColor(white)
  end;



  function f_taste(blink:boolean):boolean; {Funktionstaste?}
  begin
     blinker(true);
     if blink then while not keypressed do begin
        blinker(true); delay(200);
        blinker(false); delay(200)
     end;
     c:=readkey;
     f_taste:=c=#0;          {Funktionstaste wurde gedrckt}
     if c=#0 then c:=readkey; {wenn Funktionstaste: welche?}
  end;



  procedure bild_neu;      {Zeichnet Raster und Zeichen neu}
  begin
    with userfont,info^ do begin
     cx:=cx_g; cy:=cy_g+faktor*unterlaengen;
     bar(0,0,txof-1,cy_g+ty);       {Raster-Bereich lschen}
     for s:=0 to breite^[b] do    {x-Achse: doppelte Punkte}
        putpixel(cx+round(faktor*s/korr_faktor)-1,cy,15);
     for s:=0 to breite^[b] do                    { Raster }
       for k:=unterlaengen to hoehe do
        putpixel(cx+round(faktor*s/korr_faktor),cy-faktor*k,15);
     for k:=unterlaengen to hoehe do
       if k mod 5 = 0 then begin             { Ma-Striche }
          putpixel(cx-1,cy-faktor*k,1);       { y - Achse  }
          putpixel(cx-2,cy-faktor*k,1);
          moveto(0,cy-faktor*k);
          str(k:3,st); meintext(4,st)
       end;
     for s:=0 to breite^[b] do                { x - Achse  }
       if s mod 5 = 0 then begin
          putpixel(cx+round(faktor/korr_faktor*s),
                   cy-faktor*unterlaengen+1,4);
          putpixel(cx+round(faktor/korr_faktor*s),
                   cy-faktor*unterlaengen+2,4);
          str(s,st);
          moveto(cx+round(faktor/korr_faktor*s)-5,
                 cy-faktor*unterlaengen-1);
          meintext(4,st);
       end;
     moveto(cx,cy);
     zeichne(userfont,b,false,faktor,0);            { Bild }
    end
  end;



  procedure vector_schreiben(n:byte);
                                 {Koordinaten eines Knotens}
  begin
    with userfont do begin
      moveto(tx*(n and $F)+2,cy_t+(ty+1)*(n shr 4));
      case decodiere_vektor(vect^[Knoten[n]],vect^[Knoten[n]+1],
                         x,y,linie) of
      normal: begin
               bar(getX,getY-ty+2,getX+tx-3,getY+1);
               str(x:2,st); meintext(5,st);
               str(y:2,st); meintext(5,'/'+st);
               if linie then
                  line(getX-tx+8,getY+1,getX+3,getY+1)
              end;
      ref_zeichen:begin       {wird erst in Teil 3 bentigt}
               bar(getX,getY-ty+2,getX+2*tx-3,getY+1);
               str(vect^[Knoten[n]+1],st);
               meintext(5,'R'+#26+st+': ');
               str(vect^[Knoten[n]+2]:2,st);
               meintext(5,st)
              end;
      texte : begin           {wird erst in Teil 3 bentigt}
               bar(getX,getY-ty+2,getX+2*tx-3,getY+1);
               str(vect^[Knoten[n]+2]:3,st);
               meintext(5,'Txt'+st+':');
               str(vect^[Knoten[n]+1]*2:2,st);
               meintext(5,st)
              end;
      kreis : begin           {wird erst in Teil 3 bentigt}
               bar(getX,getY-ty+2,getX+2*tx-3,getY+1);
               str(vect^[Knoten[n]+2] and $3F,st);
               meintext(5,'Ellip '+st+'/');
               str(vect^[Knoten[n]+3] and $3F,st);
               meintext(5,st)
              end
      end
    end
  end;



  procedure vector_plus_minus(n:integer);
                        { n Eckpunkte einfgen oder lschen}
  begin
    with userfont do begin
     if n>0 then                  {Liste nach oben oder ...}
       move(vect^[paar],vect^[paar+2*n],
            umfang-128-info^.vect_anfang-paar)
     else                          {nach unten verschieben }
       move(vect^[paar-2*n],vect^[paar],
            umfang-128-info^.vect_anfang-paar+2*n);
     for k:=b+1 to info^.anfang+info^.anzahl-1 do
       inc(offs^[k],2*n);             {Adressen korrigieren}
     if (n=1) and (vec_art(knoten[akt])<>normal)
              and (paar=knoten[akt])
     then begin                     {normalen Vektor setzen}
             vect^[knoten[akt]]:=$80;
             vect^[knoten[akt]+1]:=0
           end;
     inc(anz,n); inc(paar,2*n); inc(umfang,2*n)
    end
  end;



  procedure vector_neu;      {schreibt alle Koordinaten neu}
  begin                      {und zhlt "echte" Knoten usw.}
    setFillStyle(EmptyFill,Black);
    bar(0,cy_t-ty,getMaxX,getMaxY);
    anz:=0; paar:=off; knoten[0]:=off;
    with userfont do
      while (vect^[knoten[anz]+2]<>0) or
            (vect^[knoten[anz]+3]<>0) do
      begin
         vector_schreiben(anz);
         case vec_art(knoten[anz]) of
           normal: begin inc(anz); inc(paar,2) end;
           ref_zeichen,      {wird erst in Teil 3 bentigt}
           kreis : begin knoten[anz+1]:=knoten[anz];
                     inc(anz,2); inc(paar,4);
                     if anz+1=akt then dec(akt)
                   end;
           texte : begin knoten[anz+1]:=knoten[anz];
                     inc(paar,vect^[knoten[anz]+2]+3);
                     inc(anz,2);
                     if anz+1=akt then dec(akt)
                   end
           else exit
         end; {case}
         knoten[anz]:=paar     {Offset des nchsten Knotens}
      end; {while}
    if akt>anz-1 then begin
      akt:=anz-1;
      if vec_art(knoten[akt])<>normal then dec(akt)
    end;
    rahmen(white)
  end;



  function vec_laenge(b0:word):word;
               {Ermittelt Anzahl der Vektoren einer Graphik}
  begin
    with userfont,info^ do
    if b0<anfang+anzahl-1 then
          vec_laenge:= offs^[b0+1]-offs^[b0]
     else vec_laenge:= umfang-128-vect_anfang-offs^[b0];
  end;



  procedure kopieren;          {Kopiert ein anderes Zeichen}
  var altlaenge,neulaenge,i : word;
  begin
     restoreCrtMode; clrscr;
     writeln('Sie kopieren nun ein anderes Bild und lschen'+
             ' das aktuelle Bild!');
     writeln;
     writeln('Welches Bild soll kopiert werden? (0=Ende)');
     i:=bildwahl;
     if i>0 then with userfont do begin
        neulaenge:=vec_laenge(i);     {Platzbedarf anpassen}
        altlaenge:=vec_laenge(b);
        if altlaenge<>neulaenge then begin
           paar:=knoten[anz];
           vector_plus_minus((neulaenge-altlaenge) div 2)
        end;
        move(vect^[offs^[i]],vect^[offs^[b]],neulaenge);
        breite^[b]:=breite^[i]
     end;
     setGraphMode(GraphMode);
     akt:=0; vector_neu
  end;



  procedure text_eingeben; {Plaziert freien Text in Graphik}
  begin                                    {Folgt in Teil 3}
  end;



  procedure referenz;           {Blendet andere Graphik ein}
  begin                                    {Folgt in Teil 3}
  end;



  procedure kreis_zeichnen;   {Zeichnet Kreis+Ellipse/Teile}
  begin                                    {Folgt in Teil 3}
  end;



begin                                             {von EDIT}
  with userfont do begin
   off:=offs^[b]; cleardevice;
   akt:=0; vector_neu; bild_neu;
   str(b,st);
   moveto(txof,ty-2);
   meintext(5,'Sie bearbeiten:');
   moveto(txof,2*ty-2);
   meintext(5,'   Bild '+st);
   moveto(txof,cy_g);
   meintext(5,'unterstrichen => ');
   moveto(txof,cy_g+ty);
   meintext(5,'           Linie sichtbar');
   repeat                                 {Men erste Ebene}
     bar(txof,2*ty,getMaxX,cy_g-ty-1);
     moveto(txof,4*ty);
     meintext(5,'Knoten anwhlen --> ['#27#26']');
     moveto(txof,6*ty);
     meintext(5,'Knoten einfgen --> [F1]');
     moveto(txof,7*ty);
     meintext(5,'Knoten lschen  --> [F2]');
     moveto(txof,9*ty);
     meintext(5,'Bild kopieren   --> [F4]');
     moveto(txof,11*ty);
     meintext(5,'Raster breiter  --> [F7]');
     moveto(txof,12*ty);
     meintext(5,'Raster schmaler --> [F8]');
     moveto(txof,14*ty);
     meintext(5,'alles lschen   --> [F10]');
     moveto(txof,16*ty);
     meintext(5,'Verndern(MEN 2)-> [V]');
     moveto(txof,18*ty);
     meintext(5,'Ende (HAUPTMEN)--> [ESC]');
     while f_taste(not blink) do begin     {Funktionstaste ?}
        blinker(false); paar:=knoten[akt];
        case c of
          'K': if akt>0 then begin                  (*  <  *)
                 rahmen(black);
                 if vec_art(knoten[akt-1])=normal
                    then dec(akt,1)
                 else dec(akt,2);
                 rahmen(white)
               end;
          'M': if akt<anz-1 then begin              (*  >  *)
                 rahmen(black);
                 if vec_art(knoten[akt]) = normal
                    then inc(akt,1)
                 else if akt<anz-2 then inc(akt,2);
                 rahmen(white)
               end;
          ';': begin vector_plus_minus(1);           (* F1 *)
                 inc(akt); vector_neu
               end;
          '<': if anz>1 then begin                   (* F2 *)
                case vec_art(knoten[akt]) of
                  normal: vector_plus_minus(-1);
                  kreis,ref_zeichen: vector_plus_minus(-2);
                  texte: begin paar:=knoten[akt+2];
                           vector_plus_minus((knoten[akt]-
                                      knoten[akt+2])div 2)
                         end
                end;
                vector_neu
               end;
          'D': begin paar:=knoten[0];                (* F0 *)
                 akt:=0;
                 vector_plus_minus(-vec_laenge(b) div 2 + 3);
                 vect^[off]:=$80; vect^[off+1]:=0;
                 vector_neu
               end;
          '>': kopieren;                             (* F4 *)
          'B': if breite^[b]>1 then begin dec(breite^[b]);
                  dec(vect^[knoten[anz]])            (* F8 *)
               end;
          'A': if breite^[b]<127 then begin inc(breite^[b]);
                  inc(vect^[knoten[anz]])            (* F7 *)
               end;
        end;  {case c}
        if (c in ['<','D','>','B','A']) and not keypressed
           then bild_neu;
     end;  {while}
     if upcase(c)='V'then                 {Men "Verndern"}
      case vec_art(knoten[akt]) of
       normal :
        begin                                {Men "normal"}
         bar(txof,2*ty,getMaxX,cy_g-ty-1);
         moveto(txof,4*ty);
         meintext(5,'Punkt schieben  --> ['#18#29']');
         moveto(txof,6*ty);
         meintext(5,'Linie sichtbar  --> [Ins]');
         moveto(txof,7*ty);
         meintext(5,'Linie unsichtbar--> [Del]');
         moveto(txof,9*ty);
         meintext(5,'Bild einblenden --> [F5] ');
         moveto(txof,10*ty);
         meintext(5,'Ellipse zeichnen--> [F6] ');
         moveto(txof,12*ty);
         meintext(5,'Text eingeben   --> [F9] ');
         moveto(txof,18*ty);
         meintext(5,'Ende (MEN 1)   --> [E]');
         repeat
          if f_taste(blink) then begin
           case c of
            'H': vect^[knoten[akt]+1]:=              (* ^ *)
                         (vect^[knoten[akt]+1] and $80) or
                         (vect^[knoten[akt]+1]+1) and $7F;
            'K': if vect^[knoten[akt]]>$80 then      (* < *)
                    dec(vect^[knoten[akt]]);
            'M': inc(vect^[knoten[akt]]);            (* > *)
            'P': vect^[knoten[akt]+1]:=              (* v *)
                         (vect^[knoten[akt]+1] and $80) or
                         (vect^[knoten[akt]+1]-1) and $7F;
            '?': referenz;                          (* F5 *)
            '@': kreis_zeichnen;                    (* F6 *)
            'C': text_eingeben;                     (* F9 *)
            'R': vect^[knoten[akt]+1]:=             (*Ins *)
                         vect^[knoten[akt]+1] or $80;
            'S': vect^[knoten[akt]+1]:=             (*Del *)
                         vect^[knoten[akt]+1] and $7F;
           end;
           vector_schreiben(akt);
           if not keypressed then bild_neu
          end
         until upcase(c) in ['E','?','@','C',#13]
        end; {normal}
       ref_zeichen,kreis,texte:       {Men "Einblendungen"}
        begin                 {wird erst in Teil 3 bentigt}
         bar(txof,2*ty,getMaxX,cy_g-ty-1);
         str(vect^[knoten[akt]+1],st);
         moveto(txof,3*ty);
         case vec_art(knoten[akt]) of
          ref_zeichen: meintext(5,'Referenz '#26' Bild '+st);
          kreis      : meintext(5,'Ellipse (Kreis)');
          texte      : begin meintext(5,'Text, ');
                         str(vect^[knoten[akt]+2]:2,st);
                         meintext(5,'Lnge '+st+', ')
                       end
         end;
         moveto(txof,6*ty);
         meintext(5,'verschieben: Vektor links');
         moveto(txof,8*ty);
         meintext(5,'grer / kleiner--> [+/-]');
         moveto(txof,9*ty);
         meintext(5,'drehen  --> [PgUp] [PgDn]');
         moveto(txof,18*ty);
         meintext(5,'        Ende    -->   [E]');
         repeat
          bar(txof,4*ty,getMaxX,5*ty); moveto(txof,5*ty);
          str(vect^[knoten[akt]+2]:2,st);
          case vec_art(knoten[akt]) of
            ref_zeichen: begin
                           meintext(5,'Gre '+st+'/16, ');
                           str(vect^[knoten[akt]+3]*2,st)
                         end;
            kreis:       str(vect^[knoten[akt]] and $F *3,st);
            texte:       begin
                           str(vect^[knoten[akt]] and $F,st);
                           meintext(5,'Gre '+st+', ');
                           str(vect^[knoten[akt]+1]*2,st)
                         end;
          end;
          meintext(5,'Drehung '+st+'');
          if f_taste(blink) then
           case c of
            'Q': case vec_art(knoten[akt]) of     (* PgDn *)
                  ref_zeichen:
                    if vect^[knoten[akt]+3]=0 then
                      vect^[knoten[akt]+3]:=179
                    else dec(vect^[knoten[akt]+3]);
                  kreis:
                    if vect^[knoten[akt]] and $F >0 then
                      dec(vect^[knoten[akt]])
                    else inc(vect^[knoten[akt]],$F);
                  texte:
                    if vect^[knoten[akt]+1]=0 then
                      vect^[knoten[akt]+1]:=179
                    else dec(vect^[knoten[akt]+1])
                 end;
            'I': case vec_art(knoten[akt]) of     (* PgUp *)
                  ref_zeichen: inc(vect^[knoten[akt]+3]);
                  kreis:
                    if vect^[knoten[akt]] and $F <$F then
                      inc(vect^[knoten[akt]])
                    else dec(vect^[knoten[akt]],$F);
                  texte:
                    if vect^[knoten[akt]+1]=179 then
                      vect^[knoten[akt]+1]:=0
                    else inc(vect^[knoten[akt]+1])
                 end
           end {case c...}
          else case c of
            '+': case vec_art(knoten[akt]) of
                  ref_zeichen: inc(vect^[knoten[akt]+2]);
                  kreis:
                    if (vect^[knoten[akt]+2] and $3F<$3F) then
                       inc(vect^[knoten[akt]+2]);
                  texte:
                    if (vect^[knoten[akt]] and $F < $F) then
                       inc(vect^[knoten[akt]])
                 end;
            '-': case vec_art(knoten[akt]) of
                  ref_zeichen: dec(vect^[knoten[akt]+2]);
                  kreis:
                    if (vect^[knoten[akt]+2] and $3F>0) then
                       dec(vect^[knoten[akt]+2]);
                  texte:
                    if (vect^[knoten[akt]] and $F > 1) then
                                  {Maske fr unteres Nibble}
                       dec(vect^[knoten[akt]])
                 end;
          end;  {if f_taste ...}
          if c in ['I','Q','+','-'] then begin
             vector_schreiben(akt);
             if not keypressed then bild_neu
          end
         until upcase(c)='E'
        end  {ref_zeichen, kreis, texte}
      end  {case vec_art}
   until c=#27
  end     {with}
end;     {Edit}



procedure editieren;             { Rahmenprozedur fr EDIT }
var nr:word;
begin
  with userfont,info^ do
    faktor:=cy_g div (hoehe-unterlaengen);
  gotoxy(1,16);
  nr:=bildwahl;
  if nr>0 then begin
     setGraphMode(GraphMode);
     edit(nr);
     restoreCrtMode
  end
end;

(*-------------------------------------------------------*)
(*              Ende von GR-EDIT2.INC                    *)
