(* ------------------------------------------------- *)
(*                    HCDEMO.PAS                     *)
(* ------------------------------------------------- *)
PROGRAM HCDemo;

USES PGraph, HardCopyBib, Graph;

VAR
  x, y           : Vektor;
  i, n           : WORD;
  x1, x2, y1, y2 : REAL;
BEGIN
  n := 100;
  x1 := -2 * Pi;  x2 := 2 * Pi;
  y1 := -2.5;     y2 := +2.5;             { Datensatz }
  FOR i := 1 TO n DO BEGIN
    x[i] := x1 + (i-1) * (x2-x1) / (n-1);
    y[i] := Sin(1.7 * x[i]) + 2.5 * Cos(0.8 * x[i]);
  END;
  HardcopyOn;       { Methode 1:  Hardcopy aktivieren }
  Geraet := Drucker;                { Grafik erzeugen }
  OpenGraphik;
  GraphikWindow(70, GetMaxX-20, 45, GetMaxY-20);
  Uscale(x1, x2, y1, y2, TRUE, TRUE, 5);
  XAxis(x1, x2, 'x', SmallFont, 5); Xgrid(0);
  YAxis(y1, y2, 'y', SmallFont, 5); Ygrid(0);
  Curve(x, y, n, SolidLn, NormWidth, 15);
  TestHardcopy;    { Methode 2:  Hardcopy mit *-Taste }
  CloseGraphik;
  HardCopyOff;    { Methode 1:  Hardcopy deaktivieren }
END.
(* ------------------------------------------------- *)
(*               Ende von HCDEMO.PAS                 *)