(* ------------------------------------------------------ *)
(*                    HGCINIT.PAS                         *)
(* Schaltet die Herculeskarte in Graphikmodus um. Die     *)
(* anderen Videoadapter werden ganz normal initialisiert. *)
(*        (c) 1989 Maximilian Mayr  &  TOOLBOX            *)
(* ------------------------------------------------------ *)
UNIT HGCInit;

INTERFACE

USES Crt, Dos, Graph;

  PROCEDURE Init_Graphic;

IMPLEMENTATION

  PROCEDURE Init_Graphic;
  VAR
    GraphDriver, GraphMode : INTEGER;
    ErrorCode              : INTEGER;
  BEGIN
    DetectGraph(GraphDriver, GraphMode);
    IF GraphDriver = CGA THEN BEGIN
      GraphDriver := CGA;
      GraphMode   := CGAHi;
    END ELSE
      IF GraphDriver = Hercmono THEN BEGIN
        Mem [$40:$49] := 6;
        GraphMode     := HercmonoHi;
      END ELSE
        GraphDriver := Detect;
    InitGraph(GraphDriver, GraphMode, '');
    ErrorCode := GraphResult;
    IF ErrorCode <> 0 THEN BEGIN
      WriteLn('Grafik-Fehler: ', GraphErrorMsg(ErrorCode));
      WriteLn('Programm abgebrochen ....');
      Halt(1);
    END;
  END;

END.
(* ------------------------------------------------------ *)
(*                Ende von HGCINIT.PAS                    *)
